_addon.name = "LinkCloud";
_addon.author = "James Alexander";
_addon.version = "0.1.2w";
_addon.commands = {
	"lcloud",
	"linkcloud",
	"lc"
};
require("logger");
require("chat");
defaults = {};
defaults.HostAddress = "linkcloud.drunken.games";
defaults.HostPort = 6033;
defaults.TCPTimeout = 2;
defaults.AuthKey = "NONE";
defaults.AutoConnect = true;
defaults.AutoReconnect = true;
defaults.Platform = 1;
defaults.ProcessShouts = false;
json = require("lunajson");
files = require("files");
config = require("config");
settings = config.load(defaults);
linkCloud = require("LinkCloudRoutine")

function getPlayerData() 
	return windower.ffxi.get_player()
end
function getServerData()
	return windower.ffxi.get_info()
end
function sendInputCommand(command)
	return windower.chat.input(command)
end
function sendNoticeMessage(message)
	notice(message)
end
function sendErrorMessage(message)
	error(message)
end
function saveSettings() 
	settings:save()
end
function playerIsLsOwner()
	return true
end

linkCloudParams = {
	json = json,
	settings = settings,
	getPlayerData = getPlayerData, --must gave .id, .name
	getServerData = getServerData, --must have .time .server
	sendInputCommand = sendInputCommand, --method to write a console command 
	sendNoticeMessage = sendNoticeMessage, --method to send chat notice to player
	sendErrorMessage = sendErrorMessage, --method to send error notice to player
	playerIsLsOwner = playerIsLsOwner, --method to determine if player is ls owner
	saveAddonConfig = saveSettings, --method to save addon config
	consoleLog = print
}

linkCloud.hook(linkCloudParams)


windower.register_event("incoming text", function(_, text, mode, modemod, blocked)
	if blocked or text == "" then
		return;
	end;
	if mode == 217 then --lsmes2 update
		linkCloud.onLSMesUpdate(2, text:strip_format())
	elseif mode == 205 then --lsmes update
		linkCloud.onLSMesUpdate(1, text:strip_format())
	elseif (mode == 6 or mode == 14) then --ls1 chat 
		linkCloud.onLSMessageReceived(1, text:strip_format())
	elseif (mode == 213 or mode == 214) then --ls2 chat
		linkCloud.onLSMessageReceived(2, text:strip_format())
	elseif mode == 11 then --bot spa...i mean shouts
		linkCloud.onShoutReceived(text:strip_format())
	end;
end);


windower.register_event("addon command", function(command, ...)
	command = command and command:lower() or "help";
	local args = T({
		...
	});
	if command == "connect" or command == "c" then
		linkCloud.ConnectToDiscordBot();
	elseif command == "status" or command == "s" then
		linkCloud.showstatus();
	elseif command == "test" then
		print(windower.ffxi.get_player().linkshell_slot)
	elseif command == "addlinkshell" then
		linkCloud.sendLinkshellAddRequest(args[1]);
	elseif command == "autoconnect" then
		linkCloud.cmdToggleAutoConnect()
	elseif command == "autoreconnect" then
		linkCloud.cmdToggleAutoReconnect()
	elseif command == "shouts" then
		linkCloud.cmdToggleShouts()
	elseif command == "v" or command == "ver" or command == "version" then
		linkCloud.cmdShowVersion(_addon.version)
	elseif command == "help" or command == "h" then
		linkCloud.cmdShowHelpMenu()
	else
		error(" ***** That is not a valid LinkCloud command. See //lcloud help. *****");
	end;
end);
